Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 1 | #!/bin/sh |
Greg Kroah-Hartman | b244131 | 2017-11-01 15:07:57 +0100 | [diff] [blame] | 2 | # SPDX-License-Identifier: GPL-2.0 |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 3 | # Disassemble the Code: line in Linux oopses |
| 4 | # usage: decodecode < oops.file |
| 5 | # |
| 6 | # options: set env. variable AFLAGS=options to pass options to "as"; |
| 7 | # e.g., to decode an i386 oops on an x86_64 system, use: |
| 8 | # AFLAGS=--32 decodecode < 386.oops |
| 9 | |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 10 | cleanup() { |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 11 | rm -f $T $T.s $T.o $T.oo $T.aa $T.dis |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 12 | exit 1 |
| 13 | } |
| 14 | |
| 15 | die() { |
| 16 | echo "$@" |
| 17 | exit 1 |
| 18 | } |
| 19 | |
| 20 | trap cleanup EXIT |
| 21 | |
| 22 | T=`mktemp` || die "cannot create temp file" |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 23 | code= |
Andy Shevchenko | 7e68b36 | 2018-01-31 16:14:10 -0800 | [diff] [blame] | 24 | cont= |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 25 | |
| 26 | while read i ; do |
| 27 | |
| 28 | case "$i" in |
| 29 | *Code:*) |
| 30 | code=$i |
Andy Shevchenko | 7e68b36 | 2018-01-31 16:14:10 -0800 | [diff] [blame] | 31 | cont=yes |
| 32 | ;; |
| 33 | *) |
| 34 | [ -n "$cont" ] && { |
| 35 | xdump="$(echo $i | grep '^[[:xdigit:]<>[:space:]]\+$')" |
| 36 | if [ -n "$xdump" ]; then |
| 37 | code="$code $xdump" |
| 38 | else |
| 39 | cont= |
| 40 | fi |
| 41 | } |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 42 | ;; |
| 43 | esac |
| 44 | |
| 45 | done |
| 46 | |
| 47 | if [ -z "$code" ]; then |
Randy Dunlap | fa220d8 | 2008-01-14 15:18:31 -0800 | [diff] [blame] | 48 | rm $T |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 49 | exit |
| 50 | fi |
| 51 | |
| 52 | echo $code |
| 53 | code=`echo $code | sed -e 's/.*Code: //'` |
| 54 | |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 55 | width=`expr index "$code" ' '` |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 56 | width=$((($width-1)/2)) |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 57 | case $width in |
| 58 | 1) type=byte ;; |
| 59 | 2) type=2byte ;; |
| 60 | 4) type=4byte ;; |
| 61 | esac |
| 62 | |
Marc Zyngier | c5cfb62f | 2018-12-28 00:31:21 -0800 | [diff] [blame] | 63 | if [ -z "$ARCH" ]; then |
| 64 | case `uname -m` in |
| 65 | aarch64*) ARCH=arm64 ;; |
| 66 | arm*) ARCH=arm ;; |
| 67 | esac |
| 68 | fi |
| 69 | |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 70 | disas() { |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 71 | ${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1 |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 72 | |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 73 | if [ "$ARCH" = "arm" ]; then |
| 74 | if [ $width -eq 2 ]; then |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 75 | OBJDUMPFLAGS="-M force-thumb" |
| 76 | fi |
| 77 | |
| 78 | ${CROSS_COMPILE}strip $1.o |
| 79 | fi |
| 80 | |
Will Deacon | be9fa66 | 2018-01-18 16:33:57 -0800 | [diff] [blame] | 81 | if [ "$ARCH" = "arm64" ]; then |
| 82 | if [ $width -eq 4 ]; then |
| 83 | type=inst |
| 84 | fi |
| 85 | |
| 86 | ${CROSS_COMPILE}strip $1.o |
| 87 | fi |
| 88 | |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 89 | ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \ |
Rabin Vincent | b396aa0 | 2010-06-03 22:48:12 +0530 | [diff] [blame] | 90 | grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1 |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 91 | } |
| 92 | |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 93 | marker=`expr index "$code" "\<"` |
| 94 | if [ $marker -eq 0 ]; then |
| 95 | marker=`expr index "$code" "\("` |
| 96 | fi |
| 97 | |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 98 | touch $T.oo |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 99 | if [ $marker -ne 0 ]; then |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 100 | echo All code >> $T.oo |
| 101 | echo ======== >> $T.oo |
| 102 | beforemark=`echo "$code"` |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 103 | echo -n " .$type 0x" > $T.s |
| 104 | echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s |
| 105 | disas $T |
| 106 | cat $T.dis >> $T.oo |
| 107 | rm -f $T.o $T.s $T.dis |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 108 | |
| 109 | # and fix code at-and-after marker |
| 110 | code=`echo "$code" | cut -c$((${marker} + 1))-` |
| 111 | fi |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 112 | echo Code starting with the faulting instruction > $T.aa |
| 113 | echo =========================================== >> $T.aa |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 114 | code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'` |
| 115 | echo -n " .$type 0x" > $T.s |
Randy Dunlap | dcecc6c | 2007-07-15 23:41:15 -0700 | [diff] [blame] | 116 | echo $code >> $T.s |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 117 | disas $T |
| 118 | cat $T.dis >> $T.aa |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 119 | |
Borislav Petkov | 18ff44b | 2013-04-29 15:05:54 -0700 | [diff] [blame] | 120 | # (lines of whole $T.oo) - (lines of $T.aa, i.e. "Code starting") + 3, |
| 121 | # i.e. the title + the "===..=" line (sed is counting from 1, 0 address is |
| 122 | # special) |
| 123 | faultlinenum=$(( $(wc -l $T.oo | cut -d" " -f1) - \ |
| 124 | $(wc -l $T.aa | cut -d" " -f1) + 3)) |
| 125 | |
Borislav Petkov | 2a95e37 | 2012-08-15 13:00:51 +0200 | [diff] [blame] | 126 | faultline=`cat $T.dis | head -1 | cut -d":" -f2-` |
Rabin Vincent | 5358db0 | 2010-01-05 20:27:58 +0530 | [diff] [blame] | 127 | faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'` |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 128 | |
Borislav Petkov | 18ff44b | 2013-04-29 15:05:54 -0700 | [diff] [blame] | 129 | cat $T.oo | sed -e "${faultlinenum}s/^\(.*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/" |
Arjan van de Ven | 846442c | 2008-12-01 14:21:06 -0800 | [diff] [blame] | 130 | echo |
| 131 | cat $T.aa |
| 132 | cleanup |